config/routes.rb
Spree::Core::Engine.routes.draw do
  namespace :admin, path: Spree.admin_path do
    resource :just_food_settings, only: [:edit, :update] do
      post :testorder, on: :collection
    end
  end
end

app/models/spree/app_configuration_decorator.rb
module Spree
  AppConfiguration.class_eval do
    preference :justfood_enable, :boolean, default: false
    preference :justfood_site_name, :string, default: nil
    preference :justfood_api_url, :string, default: nil
    preference :justfood_username, :string, default: nil
    preference :justfood_password, :string, default: nil
    preference :justfood_customer_no, :string, default: nil
    preference :justfood_gl_account, :string, default: nil
    preference :justfood_email, :string, default: 'it-group@naturesflavors.com'
    preference :justfood_test_order_no, :string, default: nil
  end
end

app/models/spree/order_decorator.rb
Spree::Order.class_eval do

  def just_food_create_sales_order(bypass_enable=false)
    begin
      justfood_enable = Spree::Config.justfood_enable
      justfood_site_name = Spree::Config.justfood_site_name
      justfood_api_url = Spree::Config.justfood_api_url
      justfood_username = Spree::Config.justfood_username
      justfood_password = Spree::Config.justfood_password
      justfood_customer_no = Spree::Config.justfood_customer_no
      justfood_gl_account = Spree::Config.justfood_gl_account
      justfood_email = Spree::Config.justfood_email

      if justfood_email.empty?
        justfood_email = 'it-group@naturesflavors.com'
      end

      if !justfood_enable && !bypass_enable
        subject = "JustFood/#{justfood_site_name}: code is NOT enabled. DID NOT post Order ##{self.number}."
        Spree::JustFoodMailer.send_message(justfood_email, subject, "").deliver_later
        Rails.logger.info subject
        return
      end

      if justfood_site_name.empty? || justfood_api_url.empty? || justfood_username.empty? || justfood_password.empty? || justfood_customer_no.empty?
        subject = "JustFood/#{justfood_site_name}: configuration not set. DID NOT post Order ##{self.number}."
        Spree::JustFoodMailer.send_message(justfood_email, subject, "").deliver_later
        Rails.logger.info subject
        return
      end

      # soap client
      client = JustFoodAPI::V1::Client.new(justfood_site_name, justfood_api_url, justfood_username, justfood_password, justfood_customer_no, justfood_gl_account)

      # check if sales order already exists
      begin
        response = client.read_multiple(self.number)
        readmultiple_result = response.body[:read_multiple_result][:read_multiple_result]

        if !readmultiple_result.nil? && readmultiple_result.size > 0
          justfood_sales_order_no = readmultiple_result[:np_sales_order][:no]
          subject = "JustFood/#{justfood_site_name}: Order ##{self.number} already exists as JF Sales Order ##{justfood_sales_order_no}. Will NOT post again."
          Spree::JustFoodMailer.send_message(justfood_email, subject, "").deliver_later
          Rails.logger.info subject
          return false;
        end  
      rescue StandardError => e
        subject = "JustFood/#{justfood_site_name}: Order ##{self.number} FAILED to check if sales order exists. Will post order again."
        Spree::JustFoodMailer.send_message(justfood_email, subject, e.message).deliver_later
        Rails.logger.info "#{subject} StandardError: #{e.message}"
      end

      # create sales order
      response = client.create(self)
      justfood_sales_order_no = response.body[:create_result][:np_sales_order][:no];
      subject = "JustFood/#{justfood_site_name}: Order ##{self.number} posted SUCCESSFULLY. JF Sales Order ##{justfood_sales_order_no}"
      Spree::JustFoodMailer.send_message(justfood_email, subject, "").deliver_later
      Rails.logger.info subject

      # update database with sales order no
      begin
        if self.update_attributes(justfood_sales_order_no: justfood_sales_order_no)
          subject = "JustFood/#{justfood_site_name}: Order ##{self.number} SUCCESSFULLY updated justfood_sales_order_no field. JF Sales Order ##{justfood_sales_order_no}"
          Spree::JustFoodMailer.send_message(justfood_email, subject, "").deliver_later
          Rails.logger.info subject
        else
          subject = "JustFood/#{justfood_site_name}: Order ##{self.number} FAILED to update database justfood_sales_order_no field. JF Sales Order ##{justfood_sales_order_no}"
          Spree::JustFoodMailer.send_message(justfood_email, subject, "").deliver_later
          Rails.logger.info subject
        end
      rescue StandardError => e
        subject = "JustFood/#{justfood_site_name}: Order ##{self.number} FAILED to update database justfood_sales_order_no field. JF Sales Order ##{justfood_sales_order_no}."
        Spree::JustFoodMailer.send_message(justfood_email, subject, e.message).deliver_later
        Rails.logger.info "#{subject} StandardError: #{e.message}"
      end
    rescue StandardError => e
      subject = "JustFood/#{justfood_site_name}: Order ##{self.number} FAILED to post."
      Spree::JustFoodMailer.send_message(justfood_email, subject, e.message).deliver_later
      Rails.logger.info "#{subject} StandardError: #{e.message}"
    end
  end

end

#Spree::Order.state_machine.after_transition :to => :complete,
#                                            :do => :just_food_create_sales_order

app/controllers/spree/admin/just_food_settings_controller.rb
module Spree
  module Admin
    class JustFoodSettingsController < Spree::Admin::BaseController
      
      def update
        params.each do |name, value|
          next unless Spree::Config.has_preference? name
          Spree::Config[name] = value
        end

        flash[:success] = Spree.t(:successfully_updated, resource: Spree.t(:just_food_settings))
        redirect_to edit_admin_just_food_settings_url
      end

      def testorder()
        justfood_test_order_no = Spree::Config.justfood_test_order_no
        
        if justfood_test_order_no.empty?
          flash[:error] = Spree.t('just_food.testorders.set_test_orders')
          return redirect_to edit_admin_just_food_settings_url
        end

        success = true
        failed_order_nums = []
        justfood_test_order_no.split(',').each do |order_no|
          order = Spree::Order.find_by(number: order_no)
          if order
            order.just_food_create_sales_order(true)
          else
            failed_order_nums << order_no
            success = false
          end
        end

        if success
          flash[:success] = Spree.t('just_food.testorders.check_email_for_post_messages')
          return redirect_to edit_admin_just_food_settings_url
        else
          flash[:error] = Spree.t('just_food.testorders.can_not_find_orders', nums: failed_order_nums.join(', '))
          return redirect_to edit_admin_just_food_settings_url
        end
      end
    end
  end
end

app/views/spree/admin/just_food_settings/_form.html.erb
<div data-hook="admin_just_food_form_fields">
  <div class="row">

    <div class="col-md-6" data-hook="general">
      <fieldset>
        <legend><%= Spree.t(:general) %></legend>

        <div class="form-group">
          <div class="inline-radio">
            <%= label_tag :justfood_enable do %>
              <%= preference_field_tag(:justfood_enable, Spree::Config[:justfood_enable], type: :boolean) %>
              <%= Spree.t(:enable) %>
            <% end %>
          </div>
        </div>

        <div class="form-group">
          <%= label_tag :justfood_site_name, Spree.t(:site_name) %>
          <%= text_field_tag :justfood_site_name, Spree::Config[:justfood_site_name], class: 'form-control' %>
        </div>

        <div class="form-group">
          <%= label_tag :justfood_api_url, Spree.t(:api_url) %>
          <%= text_field_tag :justfood_api_url, Spree::Config[:justfood_api_url], class: 'form-control' %>
        </div>

        <div class="form-group">
          <%= label_tag :justfood_username, Spree.t(:username) %>
          <%= text_field_tag :justfood_username, Spree::Config[:justfood_username], class: 'form-control' %>
        </div>

        <div class="form-group">
          <%= label_tag :preferred_justfood_password, Spree.t(:password) %>
          <%= password_field_tag :justfood_password, Spree::Config[:justfood_password], class: 'form-control', autocomplete: 'off' %>
        </div>

        <div class="form-group">
          <%= label_tag :justfood_customer_no, Spree.t(:customer_no) %>
          <%= text_field_tag :justfood_customer_no, Spree::Config[:justfood_customer_no], class: 'form-control' %>
        </div>

        <div class="form-group">
          <%= label_tag :justfood_gl_account, Spree.t(:shipping_gl_account) %>
          <%= text_field_tag :justfood_gl_account, Spree::Config[:justfood_gl_account], class: 'form-control' %>
        </div>

        <div class="form-group">
          <%= label_tag :justfood_email, Spree.t(:email_address_for_messages) %>
          <%= text_field_tag :justfood_email, Spree::Config[:justfood_email], class: 'form-control' %>
        </div>

        <div class="form-group">
          <%= label_tag :justfood_test_order_no, Spree.t(:test_order_numbers) %>
          <%= text_field_tag :justfood_test_order_no, Spree::Config[:justfood_test_order_no], class: 'form-control' %>
          <span class="info">
            <%= Spree.t(:test_order_numbers_comma_separated) %>
          </span>
        </div>

      </fieldset>
    </div>
  </div>
</div>

app/views/spree/admin/just_food_settings/edit.html.erb
<% content_for :page_title do %>
  <%= Spree.t(:just_food_settings) %>
<% end %>

<% content_for :page_actions do %>
  <%= link_to_with_icon 'envelope', Spree.t('just_food.post_test_orders'), testorder_admin_just_food_settings_path,
    method: :post, title: Spree.t('just_food.post_test_orders'), class: 'test_order btn btn-default' %>
<% end %>

<%= form_tag admin_just_food_settings_path, method: :put do |f| %>
  <fieldset>
    <%= render 'form', f: f %>
    <div class="form-actions actions" data-hook="buttons"><%= button Spree.t('actions.update'), 'update' %></div>
  </fieldset>
<% end %>